package MessageBoard;

import java.awt.event.*;
import javax.swing.*;

import org.jcsp.lang.*;

public class ClientListener implements
	ActionListener, MouseListener, MouseMotionListener {

	private int id;
	private ChannelOutput privateChanOut;	// T[oɓnp`l̑M[q
	private ChannelOutput upChanOut;		// T[oւ̋p`l̑M[q
	private ChannelInputInt ackIn;			// ڑ/ؒf̊mFp`l̎M[q
	private JButton[] btn;					// {^
	private JTextField message;				// bZ[W͗pg

	private boolean state;    				// ڑ  true...online, false...offline
	private int px, py;						// }EX|C^W̕ۑ

	public ClientListener(					// {^ƃ}EX̃Xȉ
			ChannelOutput upChanOut,
			ChannelOutput privateChanOut,
			ChannelInputInt ackIn,
			JButton[] btn,
			JTextField message){
		this.upChanOut = upChanOut;
		this.privateChanOut = privateChanOut;
		this.ackIn = ackIn;
		this.btn = btn;
		this.message = message;

		this.id = -1;						// ItCłID͖
		this.state = false;
		this.px = 0; this.py = 0;
	}
	public void actionPerformed(ActionEvent e) {	// {^̏

		if (!state){ // ItC
			if (e.getSource()==btn[0]){ // ڑ{^
				upChanOut.write(new Request(Request.On, privateChanOut));	// ڑv
				id = ackIn.read();											// ڑmFiIDZbgj
				state = true;
			}
		}
		else { // IC
			if (e.getSource()==btn[1]){ // ؒf{^
				upChanOut.write(new Request(Request.Off, id));				// ؒfv
				ackIn.read();												// ؒfmF
				id = -1;													// ID
				state = false;
			}
		}
	}

	// }EX̃hbOibZ[Ẅړvj
	public void mouseDragged(MouseEvent e) {
		if (state){ // IC
			upChanOut.write(new Request(Request.Mov, id, e.getX()-px, e.getY()-py));
			px = e.getX(); py = e.getY();
		}
	}
	// }EẌړibZ[W̊l/vj
	public void mouseMoved(MouseEvent e) {
		if (state){ // IC
			upChanOut.write(new Request(Request.Set, id, e.getX(), e.getY()));
			px = e.getX(); py = e.getY();
		}
	}

	// }EX̃NbN
	public void mouseClicked(MouseEvent e) {
		if (state){ // IC
			if (javax.swing.SwingUtilities.isLeftMouseButton(e)) { 	// NbN
				if (message.getText().length() > 0) {				// bZ[WłȂƂ
					upChanOut.write(new Request(Request.Add, e.getX(), e.getY(), message.getText()));
																	// bZ[Wǉv
					message.setText("");							// bZ[W͘g̃NA
					px = e.getX(); py = e.getY();
				}
			}
			else if (javax.swing.SwingUtilities.isRightMouseButton(e)) { // ENbN
				upChanOut.write(new Request(Request.Rem, id));		// bZ[W폜v
				px = e.getX(); py = e.getY();
			}
		}
	}

	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
}
