package MessageBoard;

import java.util.ArrayList;
import org.jcsp.lang.*;
import org.jcsp.net2.JCSPNetworkException;

public class Server implements CSProcess {

	final static int idMax = 100000;		// ڑ\ȃNCAg̍ől

	ChannelInput upChanIn;					// NCAg̗vM[q
	private ArrayList<MessInfo> mList;		// \bZ[W̃Xg
	private ArrayList<Integer> idList;		// ڑ̃NCAgID̃Xg
	private ChannelOutput[] privateChanOut;	// NCAg̐p`l̕ۑpz

	public Server(ChannelInput upChanIn) {
		this.upChanIn = upChanIn;
		mList = new ArrayList<MessInfo>();
		idList = new ArrayList<Integer>();
		privateChanOut = new ChannelOutput[idMax];
	}

	public void run(){
		System.out.println("T[oғ");

		while(true){

			Request rq = (Request) upChanIn.read();		// NCAg̗vM

			switch (rq.command){

			case Request.On:			// ڑv
				if (idList.size() < idMax){		// iőڑidMax𒴂ꍇ͖̏j
					int id = freeID(idList);
					try{
						rq.chanOut.write(new Reply(Reply.On,id));	// NCAg̐p`lid𑗐M
						idList.add(new Integer(id));
						privateChanOut[id]=rq.chanOut;
						System.out.println("ڑ: "+id);
					}
					catch (JCSPNetworkException e){	// NCAgƂ̃NzOɐ؂ꂽꍇ
					}
				}
				break;

			case Request.Off:			// ؒfv
				int id = rq.id;
				try{
					privateChanOut[id].write(new Reply(Reply.Off,id));	// NCAg̐p`l֕ԐM
					putMessage(id);				// bZ[W̉
					idList = removeID(idList,id);
					System.out.println("ؒf: "+id);
				}
				catch (JCSPNetworkException e){		// NCAgƂ̃NzOɐ؂ꂽꍇ
				}
				break;

			case Request.Add: 			// bZ[Wǉ
				MessInfo m = new MessInfo(-1, rq.message, rq.x, rq.y); // ǉ͏LҖ
				mList.add(m);
				Broadcast();
				break;

			case Request.Rem: 			// bZ[W폜
				remMessage(rq.id);
				Broadcast();
				break;

			case Request.Set: 			// }EX|C^̈ړ
				putMessage(rq.id);					// W̃bZ[W̉
				getMessage(rq.id, rq.x, rq.y);		// VW̃bZ[W̊l
				Broadcast();
				break;

			case Request.Mov: 			// bZ[Ẅړ
				moveMessage(rq.id, rq.x, rq.y);
				Broadcast();
				break;

			}
		}
	}

	// ڑ̑SNCAgɃbZ[Wu[hLXg
	public void Broadcast(){
		for(int i=0; i<idList.size(); i++){
			int id = idList.get(i);
			try{
				privateChanOut[id].write(new Reply(Reply.Data,mList));
				// eNCAg̐p`lɃbZ[W𑗐MB
			}
			// NCAgƂ̃NzOɐ؂ꂽꍇ̏
			catch (JCSPNetworkException e){		// OƂď
				System.err.println("폜: "+id);
				putMessage(id);					// bZ[W̉
				idList = removeID(idList,id);	// IDXg폜
			}
		}
	}

	// free Id ̎擾
	public int freeID(ArrayList<Integer> idList){
		for(int id=0; id<idMax; id++){
			if (!containsID(idList,id)) return id;
		}
		return -1;
	}

	// Xgid܂܂邩𔻒
	public boolean containsID(ArrayList<Integer> idList, int id){
		for(int i=0; i<idList.size(); i++){
			if (idList.get(i).intValue()==id) return true;
		}
		return false;
	}

	// Xgid폜
	public ArrayList<Integer> removeID(ArrayList<Integer> idList, int id){
		ArrayList<Integer> newIdList = new ArrayList<Integer>();
		for(int i=0; i<idList.size(); i++){
			if (idList.get(i).intValue()!=id) {
				newIdList.add(idList.get(i));
			}
		}
		return newIdList;
	}

	// bZ[W̊l
	void getMessage(int id, int x, int y) {
		for (int i = 0; i < mList.size(); i++) {
			if (mList.get(i).id == -1) {
				if (mList.get(i).x < x && x < mList.get(i).x + 30 &&
					mList.get(i).y - 10 < y && y < mList.get(i).y) {
					mList.get(i).id = id;
					break;
				}
			}
		}
	}

	// bZ[W̉
	void putMessage(int id) {
		for (int i = 0; i < mList.size(); i++) {
			if (mList.get(i).id==id) {
				mList.get(i).id = -1;
				break;
			}
		}
	}

	// lbZ[Ẅړ
	void moveMessage(int id,int x, int y) {
		for (int i = 0; i < mList.size(); i++) {
			if (mList.get(i).id == id) {
				mList.get(i).x += x;
				mList.get(i).y += y;
				if (mList.get(i).x < 0) mList.get(i).x = 0;
				if (mList.get(i).y < 10) mList.get(i).y = 10;
				break;
			}
		}
	}

	// lbZ[W̍폜
	void remMessage(int id) {
		for (int i = 0; i < mList.size(); i++) {
			if (mList.get(i).id == id) {
				mList.remove(i);
				break;
			}
		}
	}

}
